import { ComponentID } from '/core/ui/utilities/utilities-component-id.js';
import { RosettaSettings } from 'fs://game/seelingcat-rosetta/scripts/core/settings.js';

console.log("Rosetta is loaded!")
console.log(RosettaSettings.IsLeaderNames)
const sRosettaBuffer = "_XSCX_"
const iFrequency = 10

let tLOCNames = {}

GameInfo.SC_CityLOCRenameDatabase.forEach(row => {
    tLOCNames[row.LOCName] = row.RosettaTag
});

let tSwitchNames = {}
let tReverseSwitchNames = {}

GameInfo.SC_RosettaSwitcher.forEach(row => {
    tSwitchNames[row.OldTag] = row.NewTag
    tReverseSwitchNames[row.NewTag] = row.OldTag
    //console.log(row.OldTag, row.NewTag)
});

let tIndependentNames = {}

GameInfo.Independents.forEach(row => {
    tIndependentNames[row.Name] = row.IndependentType
    tIndependentNames[row.CityStateName] = row.IndependentType
});

let tLangSwitch = {}

GameInfo.SC_LanguageGroups.forEach(row => {
    //console.log(row.Language)
    //console.log(row.LanguageGroup)

    if (!tLangSwitch[row.Language]) {
        tLangSwitch[row.Language] = {}
    }

    tLangSwitch[row.Language][row.LanguageGroup] = true
});

let maxBackup = 0
GameInfo.SC_RosettaLanguageAssignments.forEach(row => {
    const priorityNum = row.Priority
    if ( priorityNum > maxBackup ) {
        maxBackup = priorityNum
    }
    //console.log(priorityNum)
    //console.log(maxBackup)
});


console.log("Rosetta is 2 loaded 2 furious!")

// a map might be more efficient, but can't seem to get it to work
// keep getting "GameInfo.SC_CityLOCRenameDatabase.map is not a function"

function rosettaFindBaseName(sName) {
    let rosettaEntry = ""

    if (tLOCNames[sName]) {
        rosettaEntry = tLOCNames[sName]
        console.log("Rosetta Base Name Identified! It's: ", rosettaEntry)

        return rosettaEntry
    }
    else if ( sName.includes(sRosettaBuffer)) {
        const stringStart = sName.indexOf(sRosettaBuffer)
        const sCityBaseName = sName.substring(12, stringStart) // cutting off the "LOC_ROSETTA_" part
        console.log("Rosetta Base Name Identified! It's: ", sCityBaseName)

        return sCityBaseName
    }
}

function rosettaDuplicateChecker(sBaseName, ogCityID) {
    let sSwitchName = ""
    let sReverseSwitchName = ""

    if (tSwitchNames[sBaseName]) {
        sSwitchName = tSwitchNames[sBaseName]
    }
    if (tReverseSwitchNames[sBaseName]) {
        sReverseSwitchName = tReverseSwitchNames[sBaseName]
    }

    // could maybe replace this with a getProperty check?
    for (const alivePlayers of Players.getAliveIds()) {
        const playerToCheck = Players.get(alivePlayers)
        let playerCities = playerToCheck.Cities.getCities()
        for (const city of playerCities) {
            if ( ComponentID.isMatch(city.id, ogCityID)) {
                //no need to compare city to itself
                console.log("this is the city we're checking for!")
            }
            else {
                let nameToTest = city.name
                console.log("investigating ", nameToTest)
                let baseNameToTest = rosettaFindBaseName(nameToTest)
                switch (baseNameToTest) {
                    case sBaseName:
                        console.log("DUPLICATE FOUND!")
                        return false;
                    case sSwitchName:
                        console.log("DUPLICATE FOUND! (Switch)")
                        return false;
                    case sReverseSwitchName:
                        console.log("DUPLICATE FOUND! (Reverse Switch)")
                        return false
                }
            }
        }
    }
    console.log("Rosetta all clear")
    return true
}

function rosettaNameSwitch(startingSwitchName, civOrLeaderTag, player) {
    const switchEntries = Database.query('gameplay', 'SELECT * FROM SC_RosettaSwitcher')?.filter(item => item.OldTag == startingSwitchName || item.NewTag == startingSwitchName)
    console.log("Number of Switch Entries: ", switchEntries.length)
    for (const entry of switchEntries) {
        let changeCriteria = ""
        let newSwitchName = ""
        if (entry.OldTag == startingSwitchName) {
            changeCriteria = entry.Trigger
            newSwitchName = entry.NewTag
        } else {
            changeCriteria = entry.ReverseTrigger
            newSwitchName = entry.OldTag
        }

        if (changeCriteria == "ANTIQUITY" || changeCriteria == "EXPLORATION" || changeCriteria == "MODERN") {
            const currentAge = GameInfo.Ages.lookup(Game.age)
            const ageType = currentAge.AgeType
            console.log("current age is ", ageType)

            if (ageType == "AGE_" + changeCriteria) {
                console.log("age change criteria satisfied!")
                console.log("returning ", newSwitchName)
                return newSwitchName
            } 
        }

        //IDEOLOGY

        if (changeCriteria == "COMMUNISM" || changeCriteria == "NONCOMMUNISM") {
            const playerIdeology = player.Culture.getChosenIdeology();
            const ideologyDef = GameInfo.Ideologies.find((item) => {
                return Database.makeHash(item.IdeologyType) == playerIdeology;
            });
            const ideologyForm = ideologyDef.IdeologyType
            console.log(ideologyForm)

            if ((changeCriteria == "COMMUNISM" && ideologyForm == "IDEOLOGY_COMMUNISM") || (changeCriteria == "NONCOMMUNISM" && ideologyForm != "IDEOLOGY_COMMUNISM")) {
                console.log("Switching names based on ideology: ", ideologyForm)
                return newSwitchName
            }
        }

        for (let i = 1; i <= maxBackup; ++i) {
            const languageAssignment = Database.query('gameplay', 'SELECT * FROM SC_RosettaLanguageAssignments')?.find(item => item.CivLeaderTag == civOrLeaderTag && item.Priority == i)
            let languageToUse = languageAssignment?.Language
            console.log(languageToUse)
            console.log(civOrLeaderTag)

            if (tLangSwitch[languageToUse] && tLangSwitch[languageToUse][changeCriteria] == true) {
                console.log("Found a Switchable Name based on: ", languageToUse, changeCriteria, " - switching to ", newSwitchName)
                return newSwitchName
            }
        }

        //const government = player.Culture?.getGovernmentType()
        //console.log(government)
        //const governmentType = GameInfo.Governments.lookup(government)
        //console.log(governmentType.GovernmentType)
    }
    return startingSwitchName
}

function rosettaFindNewCity(civType, ogCityID) {
    console.log('Searching for new city to use! ', civType)
    const cityList = Database.query('gameplay', 'SELECT * FROM CityNames')?.filter(item => item.CivilizationType == civType)
    console.log(cityList.length)
    for (const city of cityList) {
        let cityToTry = city.CityName
        console.log('lets try ', cityToTry)

        let newEntry = rosettaFindBaseName(cityToTry) || undefined

        if (newEntry !== undefined) {
            console.log("New city base name is: ", newEntry)
            let bOkayToProceed = rosettaDuplicateChecker(newEntry, city.id)

            if (bOkayToProceed == true) {
                console.log(newEntry, 'this city is okay to use!')
                return newEntry
            }
        }
    }
}

function rosettaCheckup(data) {
    let turn = Game.turn
    console.log(turn)
    console.log(data.player)

    if (turn % iFrequency == 0 || turn == 2 ) { // to account for era change; 2 is for capital change since we haven't figured out the data for that
        console.log("check-up time!")
        let playerCities = Players.get(data.player).Cities.getCities()
        for (const city of playerCities) {
            rosettaFollowThrough(city, Players.get(city.owner), false) // don't need to check for base name uniqueness.. this should be handled on city foundation/whatever we do with the capital
        }
    }
}

function rosettaStart(data) {
    console.log("ROSETTA DATA")
    console.log(data.cityID) // object
    console.log(data.player) // number - seems to work
    console.log(data.cityID.owner) // number - seems to work
    const city = Cities.get(data.cityID)
    const player = Players.get(data.player)
    console.log("ROSETTA 3")
    console.log(player)
    console.log(data.location.x) // seems to give correct number
    console.log(data.location.y) // seems to give correct number
    rosettaFollowThrough(city, player, true)
}

function rosettaFollowThrough(city, player, bNeedUnique) {
    console.log(city.name) // WORKS!
    console.log(ComponentID.toLogString(city.id))
    const cityComponentID = (ComponentID.toLogString(city.id))
    let civType = GameInfo.Civilizations.lookup(player.civilizationType).CivilizationType
    console.log(civType)
    const civAdj = player.civilizationAdjective
    console.log('adj: ', civAdj)
    let leaderType = ""
    let bIndependent = false
    if (civType == "CIVILIZATION_INDEPENDENT") {
        if (tIndependentNames[civAdj]) {
            civType = tIndependentNames[civAdj]
            leaderType = tIndependentNames[civAdj]
            bIndependent = true
        } else {
            console.log("Unknown Indpendent Power?")
        }
    }
    else {
        leaderType = GameInfo.Leaders.lookup(player.leaderType).LeaderType
    }
    console.log(leaderType)

    let year = Game.getTurnDate()

    let yearNumGrab = year.match(/(\d+)/)
    let yearNum = Number(yearNumGrab[0]) || -9999

    let yearString = Locale.compose('LOC_TIME_BC', yearNum)

    if (year == yearString) {
        console.log("We're in BCE!")
        yearNum = yearNum*-1
    } 
    console.log("Current Year is: ", yearNum)

    
    //const civName = player.civilizationName
    //console.log(civName)
    //const leaderName = player.leaderName
    //console.log(leaderName)

    let civOrLeaderTag = civType

    if (RosettaSettings.IsLeaderNames == true) {
        civOrLeaderTag = leaderType
    }



    const startingName = city.name
    console.log(startingName)

    let rosettaEntry = rosettaFindBaseName(startingName) || undefined
    console.log(rosettaEntry)


    if (rosettaEntry !== undefined) {
        console.log('Success! Moving Forward with  ', rosettaEntry)

        //check for switches
        let rosettaSwitch = rosettaNameSwitch(rosettaEntry, civOrLeaderTag, player)

        if (rosettaSwitch !== rosettaEntry) {
            const switchArgs = { Name: "LOC_ROSETTA_" + rosettaEntry + sRosettaBuffer + "LOCAL" }
            Game.CityCommands.sendRequest(city.id, CityCommandTypes.NAME_CITY, switchArgs)
            rosettaEntry = rosettaSwitch
        }

        let bDuplicateResult = true

        if (bNeedUnique == true) {
            // check for duplicates
            bDuplicateResult = rosettaDuplicateChecker(rosettaEntry, city.id)

            if ( bDuplicateResult == false ) {
                console.log('trying to find a new name')
                let newAttempt = rosettaFindNewCity(civType, city.id) || undefined
                console.log(newAttempt)
                if (newAttempt !== undefined) {
                    bDuplicateResult = true
                    rosettaEntry = newAttempt
                } else {
                    console.log('no non-duplicated names?')
                }
            }
        }

        if ( bDuplicateResult == true ) { 
            for (let i = 1; i <= maxBackup; ++i) {
                const languageAssignment = Database.query('gameplay', 'SELECT * FROM SC_RosettaLanguageAssignments')?.find(item => item.CivLeaderTag == civOrLeaderTag && item.Priority == i)
                let languageToUse = languageAssignment?.Language
                console.log(languageToUse)
                console.log(civOrLeaderTag)
                console.log(i)

                if (languageAssignment) {
                    console.log(languageAssignment?.EndYear)
                    if ( (languageAssignment.EndYear == null || yearNum <= languageAssignment.EndYear ) && (languageAssignment.StartYear == null || yearNum > languageAssignment.StartYear) ) {
                        let nameToTry = "LOC_ROSETTA_" + rosettaEntry + sRosettaBuffer + languageToUse
                        console.log(nameToTry)

                        // check for switching

                        // check for year-changed names

                        if (Locale.keyExists(nameToTry)) {
                            console.log("That name works!")
                            console.log("Checking for time-based name variant")

                            const potentialNames = Database.query('gameplay', 'SELECT * FROM SC_YearFlavor')?.filter(flavorName => flavorName.Language == languageToUse && flavorName.RosettaTag == rosettaEntry)
                            if (potentialNames) {
                                for (const yearName of potentialNames) {
                                    console.log(yearName.StartYear)
                                    console.log(yearName.EndYear)
                                    if ( yearNum <= yearName.EndYear && (yearName.StartYear == null || yearNum > yearName.StartYear) ) {
                                        console.log("success! ", yearName.YearTag)
                                        nameToTry = yearName.YearTag
                                        break
                                    }
                                }
                            } else {
                                console.log("no time-based name variants found")
                            }

                            if (startingName == nameToTry) {
                                console.log("city is already named this!")
                                break;
                            } else {
                                console.log(nameToTry)

                                const args = { Name: nameToTry };
                                Game.CityCommands.sendRequest(city.id, CityCommandTypes.NAME_CITY, args) /// ONLY WORKS ON PLAYER CITIES???
                                
                                const result = Game.CityCommands.canStart(city.id, CityCommandTypes.NAME_CITY, args, false)
                                if (result.Success) {
                                    console.log("ROSETTA SUCCESSFULLY RENAMED CITY")
                                } else {
                                    console.log("ROSETTA UNABLE TO RENAME CITY")
                                }

                                break;
                            }
                        } else {
                            console.log(nameToTry, "not found")
                            //let weirdName = "LOC_ROSETTA_" + rosettaEntry
                            //const args = { Name: weirdName };
                            //Game.CityCommands.sendRequest(city.id, CityCommandTypes.NAME_CITY, args) /// ONLY WORKS ON PLAYER CITIES???
                            //break; // somehow, removing this adds a 1 after city names - even breaking/ignoring Localization??
                        }
                    } else {
                        console.log("language is not valid for this year")
                    }
                } else {
                    console.log ("exhausted potential languages!")
                    if (bIndependent == true && startingName != "LOC_ROSETTA_" + rosettaEntry + sRosettaBuffer + "LOCAL" ) {
                        const args = { Name: "LOC_ROSETTA_" + rosettaEntry + sRosettaBuffer + "LOCAL" } // should always have a local name that independents can use
                        Game.CityCommands.sendRequest(city.id, CityCommandTypes.NAME_CITY, args)
                    }
                    break;
                }
            }
        } else {
            console.log('Rosetta could not find non-duplicated name!')
        }

    } else{
        console.log('Rosetta Entry Not Found!')
    }
}




// Register listeners.
engine.on('CityInitialized', rosettaStart);
engine.on('PlayerTurnActivated', rosettaCheckup);
//engine.on('CapitalCityChanged', rosettaStart); // seems to pass different info? need to sort out what it is
//engine.on('CityNameChanged', rosettaStart);
console.log("Rosetta online");