import { Options, OptionType } from '/core/ui/options/model-options.js';
import { CategoryType, CategoryData } from '/core/ui/options/options-helpers.js';
import { RosettaSettings } from '../core/settings.js';

// We add a dependency on the Options module to ensure default options are loaded before we add our own
import '/core/ui/options/options.js';

CategoryType["Mods"] = "mods";
CategoryData[CategoryType["Mods"]] = {
    title: "LOC_UI_CONTENT_MGR_SUBTITLE",
    description: "LOC_UI_CONTENT_MGR_SUBTITLE_DESCRIPTION",
};

const onOptionRosettaLeaderNamesInit = (optionInfo) => {
    optionInfo.currentValue = RosettaSettings.IsLeaderNames;
};
const onOptionRosettaLeaderNamesUpdate = (optionInfo, value) => {
    RosettaSettings.IsLeaderNames = value;
}

Options.addInitCallback(() => {
    Options.addOption({ 
        category: CategoryType["Mods"], 
        // @ts-ignore
        group: 'rosetta', 
        type: OptionType.Checkbox, 
        id: "rosetta-leader-names", 
        initListener: onOptionRosettaLeaderNamesInit, 
        updateListener: onOptionRosettaLeaderNamesUpdate, 
        label: "LOC_ROSETTA_LEADER_OPTION_NAME", 
        description: "LOC_ROSETTA_LEADER_OPTION_DESC" 
    });
});
